; Zombie ARM7 example
; /Mic, 2004
;
; Just fills the upper half of the screen with a light blue
;
; Assemble with goldroad (http://www.goldroad.co.uk)


@fsize 32			; Pad ROM to 32kB	
@textarea $8000000		; ROM starts at $08000000


ldr r4,=$FF00			; GPU reg0
ldr r5,=$6000000		; Frame buffer
ldr r6,=$6012C00		; Palette

mov r0,#$00			  
strb r0,[r4]			; Disable display, vblank etc

ldr r0,=$ADDF0000
str r0,[r6]			; Set color 0 to $0000 and color 1 to $ADDF (RGB565)

ldr r0,=$01010101
ldr r1,=$2580			; $2580 = 38400/4 = half the screen
draw_pixels:
	str r0,[r5],#4		; Write 4 pixels
	subs r1,r1,#1		; Decrement counter
	bne draw_pixels		; Repeat until zero
	
mov r0,#$B4
strb r0,[r4]			; Enable display, bitmapped mode 320x240x8bpp

forever:
	b forever

@ltorg				; Dump literal pool
@endarea
